﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using ImportantDemo.Data;

namespace ImportantDemo
{
    public class Program
    {
        static void Main(string[] args)
        {

            //StudentEntity student = new StudentEntity() { StuNo = "001", Name = "张三" ,Age=18};
            var student = new { StuNo = "001", Name = "张三", Age = 18 };
            Dictionary<string, object> dt = new Dictionary<string, object>();
            AddProperty("Hobby", "羽毛球", student, out dt);//新增属性


            Console.WriteLine(dt.ToJson());
            Console.ReadLine();

        }

        /// <summary>
        /// 为实体新增属性，返回字典
        /// </summary>
        /// <param name="propertyName">新增属性名称</param>
        /// <param name="propertyValue">新增属性值</param>
        /// <param name="entity">实体</param>
        /// <param name="outDic">要返回的字典</param>
        public static void AddProperty(string propertyName, object propertyValue, object entity, out Dictionary<string, object> outDic)
        {
            Dictionary<string, object> dt = new Dictionary<string, object>();

            Type t = entity.GetType();
            for (int i = 0; i < t.GetProperties().Length; i++)
            {
                dt.Add(t.GetProperties()[i].Name, t.GetProperties()[i].GetValue(entity));
            }

            if (dt.ContainsKey(propertyName) == false)
            {
                dt.Add(propertyName, propertyValue);
            }
            else
            {
                dt[propertyName] = propertyValue;
            }
            outDic = dt;

        }

    }
}
